/************************************************************************
 ************************************************************************
 ****                                                                ****
 ****    flash.c : H8-3694F tbV݃vO         ****
 ****                                                                ****
 ****----------------------------------------------------------------****
 ****                                                                ****
 ************************************************************************
 ************************************************************************/
/*
 * [U[[hł̏݊֐͖ʓ|Ȃ̂ł߂DDD
 */
#include	"fancnt.h"
#include	"h8_3694.h"

#define	SYSPARAM_TOP	(0x0400)	/* VXep[^ۑ擪AhX*/

/************************************************************************
 *    錾                                                              *
 ************************************************************************/
extern sysParam	sysp;

extern asmCopyByte(unsigned char *, unsigned char *, unsigned int);
extern asmReadByte(unsigned char *);
extern dbgout(char);
/************************************************************************
 *    VXep[^̓ǂݏo                                      *
 ************************************************************************/
int
initSysParam(void)
{
    int			i;
    unsigned int	*ptr;
    unsigned char	*sptr, *dptr;
    
    ptr = (unsigned int *)SYSPARAM_TOP;
    for(i=0; i<8; i++) {
        if (*ptr == 0xffff)	break;
        ptr = ptr + 128;
    }

    if (i == 0) {
        /* ftHglݒ */
        sysp.head = 0x0001;
        sysp.ka[0] = 64;  sysp.kb[0] =  0;  sysp.kc[0] =  0;  sysp.kd[0] =  0;
        sysp.ka[1] =  0;  sysp.kb[1] = 64;  sysp.kc[1] =  0;  sysp.kd[1] =  0;
        sysp.ka[2] =  0;  sysp.kb[2] =  0;  sysp.kc[2] = 64;  sysp.kd[2] =  0;
        sysp.ka[3] =  0;  sysp.kb[3] =  0;  sysp.kc[3] =  0;  sysp.kd[3] = 64;
        sysp.mnd[0] = 50;
        sysp.mnd[1] = 50;
        sysp.mnd[2] = 50;
        sysp.mnd[3] = 50;
        sysp.fxd[0] = 255;
        sysp.fxd[1] = 255;
        sysp.fxd[2] = 255;
        sysp.fxd[3] = 255;
        sysp.onch = 0x0f;
        sysp.onth = 0x0f;
        sysp.fxch = 0x00;
        sysp.fantype = 0x11;
        return 0;
    } else {
        /* tbVۑlǂݏo */
        sptr = (unsigned char *)(ptr -128);
        dptr = (unsigned char *)(&sysp);
        for(i=0; i<128; i++) {
            dptr[i] = sptr[i];
        }
        return 1;
    }
    return -1;
}

extern void	*eraseParam;
extern void	*saveParam;
extern void	*progsyspEnd;

int
progEnv(void)
{
    unsigned int	*ptr, *dest, *src, dat, size, i, erase;
    unsigned char	s;
    int			(*func)();

    /**** ӃW[~ ****/
    while(checkOutBuf()) { ; }
    resetSys();			/* VXe̒~ */
    initCharIO();		/* obt@ */
    while(1) {
        s = asmReadByte((unsigned char *)0xffac);
        if (s & 0x04) break;
    }
    
    /**** ݐ擪AhX̃T[` ****/
    ptr = (unsigned int *)SYSPARAM_TOP;
    for(i=0; i<8; i++) {
        if (*ptr == 0xffff)	break;
        ptr = ptr + 0x80;
    }
    if (i == 8) {		/* Sݍς݁čŏ */
        ptr = (unsigned int *)0x0400;
        erase = 1;
    } else {			/* ǉ݁̕KvȂ */
        erase = 0;
    }

    /**** ݃vÕRs[ ****/
    asmCopyByte((unsigned char *)0xf900, (unsigned char *)0x0800, 0x0400);

    /**** ݁u[g ****/
    FENR = 0x80;		/* tbVANZX */
    if (erase) {		/* sJnRAMAhXvZ */
        func = (void *)(0xf904);
    } else {
        dbgout('h');
        func = (void *)(0xf908);
    }
    func(ptr);
    reboot();
}

/* end of file */
